Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2696)
@@ -432,105 +970,224 @@
        REAL(wp) ::  r_dummy           !<
 
-       ALLOCATE( p_surf(0:nlsf), pt_surf(0:nlsf), q_surf(0:nlsf),              &
-                 qsws_surf(0:nlsf), shf_surf(0:nlsf),                          &
-                 td_lsa_lpt(nzb:nzt+1,0:nlsf), td_lsa_q(nzb:nzt+1,0:nlsf),     &
-                 td_sub_lpt(nzb:nzt+1,0:nlsf), td_sub_q(nzb:nzt+1,0:nlsf),     &
-                 time_vert(0:nlsf), time_surf(0:nlsf),                         &
-                 ug_vert(nzb:nzt+1,0:nlsf), vg_vert(nzb:nzt+1,0:nlsf),         &
-                 wsubs_vert(nzb:nzt+1,0:nlsf) )
-
-       p_surf = 0.0_wp; pt_surf = 0.0_wp; q_surf = 0.0_wp; qsws_surf = 0.0_wp
-       shf_surf = 0.0_wp; time_vert = 0.0_wp; td_lsa_lpt = 0.0_wp
-       td_lsa_q = 0.0_wp; td_sub_lpt = 0.0_wp; td_sub_q = 0.0_wp
-       time_surf = 0.0_wp; ug_vert = 0.0_wp; vg_vert = 0.0_wp
-       wsubs_vert = 0.0_wp
-
-!
-!--    Array for storing large scale forcing and nudging tendencies at each 
-!--    timestep for data output
-       ALLOCATE( sums_ls_l(nzb:nzt+1,0:7) )
-       sums_ls_l = 0.0_wp
-
-       ngp_sums_ls = (nz+2)*6
-
-       OPEN ( finput, FILE='LSF_DATA', STATUS='OLD', &
-              FORM='FORMATTED', IOSTAT=ierrn )
-
-       IF ( ierrn /= 0 )  THEN
-          message_string = 'file LSF_DATA does not exist'
-          CALL message( 'ls_forcing', 'PA0368', 1, 2, 0, 6, 0 )
-       ENDIF
-
-       ierrn = 0
-!
-!--    First three lines of LSF_DATA contain header
-       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-       READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
-
-       IF ( ierrn /= 0 )  THEN
-          message_string = 'errors in file LSF_DATA'
-          CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
-       ENDIF
-
-!
-!--    Surface values are read in
-       nt     = 0
-       ierrn = 0
-
-       DO WHILE ( time_surf(nt) < end_time )
-          nt = nt + 1
-          READ ( finput, *, IOSTAT = ierrn ) time_surf(nt), shf_surf(nt),      &
-                                             qsws_surf(nt), pt_surf(nt),       &
-                                             q_surf(nt), p_surf(nt)
+       IF ( forcing )  THEN
+!
+!--       Allocate arrays for reading boundary values. Arrays will incorporate 2 
+!--       time levels in order to interpolate in between. 
+          IF ( force_bound_l )  THEN
+             ALLOCATE( force%u_left(0:1,nzb+1:nzt+1,nys:nyn)  )
+             ALLOCATE( force%v_left(0:1,nzb+1:nzt+1,nysv:nyn) )
+             ALLOCATE( force%w_left(0:1,nzb+1:nzt,nys:nyn)    )
+             IF ( humidity )      ALLOCATE( force%q_left(0:1,nzb+1:nzt+1,nys:nyn)  )
+             IF ( .NOT. neutral ) ALLOCATE( force%pt_left(0:1,nzb+1:nzt+1,nys:nyn) )
+          ENDIF
+          IF ( force_bound_r )  THEN
+             ALLOCATE( force%u_right(0:1,nzb+1:nzt+1,nys:nyn)  )
+             ALLOCATE( force%v_right(0:1,nzb+1:nzt+1,nysv:nyn) )
+             ALLOCATE( force%w_right(0:1,nzb+1:nzt,nys:nyn)    )
+             IF ( humidity )      ALLOCATE( force%q_right(0:1,nzb+1:nzt+1,nys:nyn)  )
+             IF ( .NOT. neutral ) ALLOCATE( force%pt_right(0:1,nzb+1:nzt+1,nys:nyn) )
+          ENDIF
+          IF ( force_bound_n )  THEN
+             ALLOCATE( force%u_north(0:1,nzb+1:nzt+1,nxlu:nxr) )
+             ALLOCATE( force%v_north(0:1,nzb+1:nzt+1,nxl:nxr)  )
+             ALLOCATE( force%w_north(0:1,nzb+1:nzt,nxl:nxr)    )
+             IF ( humidity )      ALLOCATE( force%q_north(0:1,nzb+1:nzt+1,nxl:nxr)  )
+             IF ( .NOT. neutral ) ALLOCATE( force%pt_north(0:1,nzb+1:nzt+1,nxl:nxr) )
+          ENDIF
+          IF ( force_bound_s )  THEN
+             ALLOCATE( force%u_south(0:1,nzb+1:nzt+1,nxlu:nxr) )
+             ALLOCATE( force%v_south(0:1,nzb+1:nzt+1,nxl:nxr)  )
+             ALLOCATE( force%w_south(0:1,nzb+1:nzt,nxl:nxr)    )
+             IF ( humidity )      ALLOCATE( force%q_south(0:1,nzb+1:nzt+1,nxl:nxr)  )
+             IF ( .NOT. neutral ) ALLOCATE( force%pt_south(0:1,nzb+1:nzt+1,nxl:nxr) )
+          ENDIF
+          
+          ALLOCATE( force%u_top(0:1,nys:nyn,nxlu:nxr) )
+          ALLOCATE( force%v_top(0:1,nysv:nyn,nxl:nxr) )
+          ALLOCATE( force%w_top(0:1,nys:nyn,nxl:nxr)  )
+          IF ( humidity )      ALLOCATE( force%q_top(0:1,nys:nyn,nxl:nxr)  )
+          IF ( .NOT. neutral ) ALLOCATE( force%pt_top(0:1,nys:nyn,nxl:nxr) )
+
+!
+!--       Initial call of input. Time array, initial 3D data of u, v, w, 
+!--       potential temperature, as well as mixing ratio, will be read. 
+!--       Moreover, data at lateral and top boundary will be read.  
+          CALL netcdf_data_input_lsf
+!
+!--       Please note, at the moment INIFOR assumes only an equidistant vertical
+!--       grid. In case of vertical grid stretching, input of inital 3D data 
+!--       need to be inter- and/or extrapolated. 
+!--       Therefore, check if zw grid on file is identical to numeric zw grid.   
+          IF ( ANY( zu(1:nzt+1) /= force%zu_atmos(1:force%nzu) ) )  THEN
+!
+!--          Also data at the boundaries need to be inter/extrapolated at both
+!--          time levels
+             DO  t = 0, 1
+                IF ( force_bound_l )  THEN
+                   CALL netcdf_data_input_interpolate( force%u_left(t,:,:),    &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%v_left(t,:,:),    &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%w_left(t,:,:),    &
+                                                       zw(1:nzt+1),            &
+                                                       force%zw_atmos )
+                   IF ( .NOT. neutral )                                        &
+                      CALL netcdf_data_input_interpolate( force%pt_left(t,:,:),&
+                                                          zu(1:nzt+1),         &
+                                                          force%zu_atmos )
+                   IF ( humidity )                                             &
+                      CALL netcdf_data_input_interpolate( force%q_left(t,:,:), &
+                                                          zu(1:nzt+1),         &
+                                                          force%zu_atmos )
+                ENDIF
+                IF ( force_bound_r )  THEN
+                   CALL netcdf_data_input_interpolate( force%u_right(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%v_right(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%w_right(t,:,:),   &
+                                                       zw(1:nzt+1),            &
+                                                       force%zw_atmos )
+                   IF ( .NOT. neutral )                                        &
+                      CALL netcdf_data_input_interpolate( force%pt_right(t,:,:),&
+                                                          zu(1:nzt+1),          &
+                                                          force%zu_atmos )
+                   IF ( humidity )                                             &
+                      CALL netcdf_data_input_interpolate( force%q_right(t,:,:),&
+                                                          zu(1:nzt+1),         &
+                                                          force%zu_atmos )
+                ENDIF
+                IF ( force_bound_n )  THEN
+                   CALL netcdf_data_input_interpolate( force%u_north(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%v_north(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%w_north(t,:,:),   &
+                                                       zw(1:nzt+1),            &
+                                                       force%zw_atmos )
+                   IF ( .NOT. neutral )                                        &
+                      CALL netcdf_data_input_interpolate( force%pt_north(t,:,:),&
+                                                          zu(1:nzt+1),          &
+                                                          force%zu_atmos )
+                   IF ( humidity )                                             &
+                      CALL netcdf_data_input_interpolate( force%q_north(t,:,:),&
+                                                          zu(1:nzt+1),         &
+                                                          force%zu_atmos )
+                ENDIF
+                IF ( force_bound_s )  THEN
+                   CALL netcdf_data_input_interpolate( force%u_south(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%v_south(t,:,:),   &
+                                                       zu(1:nzt+1),            &
+                                                       force%zu_atmos )
+                   CALL netcdf_data_input_interpolate( force%w_south(t,:,:),   &
+                                                       zw(1:nzt+1),            &
+                                                       force%zw_atmos )
+                   IF ( .NOT. neutral )                                        &
+                      CALL netcdf_data_input_interpolate( force%pt_south(t,:,:),&
+                                                          zu(1:nzt+1),          &
+                                                          force%zu_atmos )
+                   IF ( humidity )                                             &
+                      CALL netcdf_data_input_interpolate( force%q_south(t,:,:),&
+                                                          zu(1:nzt+1),         &
+                                                          force%zu_atmos )
+                ENDIF
+             ENDDO
+          ENDIF
+
+!
+!--       Exchange ghost points
+          CALL exchange_horiz( u, nbgp )
+          CALL exchange_horiz( v, nbgp )
+          CALL exchange_horiz( w, nbgp )
+          IF ( .NOT. neutral )  CALL exchange_horiz( pt, nbgp )
+          IF ( humidity      )  CALL exchange_horiz( q,  nbgp )
+!
+!--       At lateral boundaries, set also initial boundary conditions
+          IF ( force_bound_l )  THEN
+             u(:,:,nxl)   = u(:,:,nxlu)
+             v(:,:,nxl-1) = v(:,:,nxl)
+             w(:,:,nxl-1) = w(:,:,nxl)
+             IF ( .NOT. neutral )  pt(:,:,nxl-1) = pt(:,:,nxl)
+             IF ( humidity      )  q(:,:,nxl-1)  = q(:,:,nxl)
+          ENDIF
+          IF ( force_bound_r )  THEN
+             u(:,:,nxr+1) = u(:,:,nxr)
+             v(:,:,nxr+1) = v(:,:,nxr)
+             w(:,:,nxr+1) = w(:,:,nxr)
+             IF ( .NOT. neutral )  pt(:,:,nxr+1) = pt(:,:,nxr)
+             IF ( humidity      )  q(:,:,nxr+1)  = q(:,:,nxr)
+          ENDIF
+          IF ( force_bound_s )  THEN
+             u(:,nys-1,:) = u(:,nys,:)
+             v(:,nys,:)   = v(:,nysv,:)
+             w(:,nys-1,:) = w(:,nys,:)
+             IF ( .NOT. neutral )  pt(:,nys-1,:) = pt(:,nys,:)
+             IF ( humidity      )  q(:,nys-1,:)  = q(:,nys,:)
+          ENDIF
+          IF ( force_bound_n )  THEN
+             u(:,nyn+1,:) = u(:,nyn,:)
+             v(:,nyn+1,:) = v(:,nyn,:)
+             w(:,nyn+1,:) = w(:,nyn,:)
+             IF ( .NOT. neutral )  pt(:,nyn+1,:) = pt(:,nyn,:)
+             IF ( humidity      )  q(:,nyn+1,:)  = q(:,nyn,:)
+          ENDIF
+
+!
+!--       After 3D data is initialized, ensure mass conservation
+          CALL forcing_bc_mass_conservation
+!
+!--       Initialize surface pressure. Please note, time-dependent surface
+!--       pressure would require changes in anelastic approximation and 
+!--       treatment of fluxes. 
+!--       For the moment, comment this out! 
+!         surface_pressure = force%surface_pressure(0)
+
+       ELSE
+
+          ALLOCATE( p_surf(0:nlsf), pt_surf(0:nlsf), q_surf(0:nlsf),           &
+                    qsws_surf(0:nlsf), shf_surf(0:nlsf),                       &
+                    td_lsa_lpt(nzb:nzt+1,0:nlsf), td_lsa_q(nzb:nzt+1,0:nlsf),  &
+                    td_sub_lpt(nzb:nzt+1,0:nlsf), td_sub_q(nzb:nzt+1,0:nlsf),  &
+                    time_vert(0:nlsf), time_surf(0:nlsf),                      &
+                    ug_vert(nzb:nzt+1,0:nlsf), vg_vert(nzb:nzt+1,0:nlsf),      &
+                    wsubs_vert(nzb:nzt+1,0:nlsf) )
+
+          p_surf = 0.0_wp; pt_surf = 0.0_wp; q_surf = 0.0_wp; qsws_surf = 0.0_wp
+          shf_surf = 0.0_wp; time_vert = 0.0_wp; td_lsa_lpt = 0.0_wp
+          td_lsa_q = 0.0_wp; td_sub_lpt = 0.0_wp; td_sub_q = 0.0_wp
+          time_surf = 0.0_wp; ug_vert = 0.0_wp; vg_vert = 0.0_wp
+          wsubs_vert = 0.0_wp
+
+!
+!--       Array for storing large scale forcing and nudging tendencies at each 
+!--       timestep for data output
+          ALLOCATE( sums_ls_l(nzb:nzt+1,0:7) )
+          sums_ls_l = 0.0_wp
+
+          ngp_sums_ls = (nz+2)*6
+
+          OPEN ( finput, FILE='LSF_DATA', STATUS='OLD', &
+                 FORM='FORMATTED', IOSTAT=ierrn )
 
           IF ( ierrn /= 0 )  THEN
-            WRITE ( message_string, * ) 'No time dependent surface variables ',&
-                              'in&LSF_DATA for end of run found'
-
-             CALL message( 'ls_forcing', 'PA0363', 1, 2, 0, 6, 0 )
-          ENDIF
-       ENDDO
-
-       IF ( time_surf(1) > end_time )  THEN
-          WRITE ( message_string, * ) 'Time dependent surface variables in ',  &
-                                      '&LSF_DATA set in after end of ' ,      &
-                                      'simulation - lsf_surf is set to FALSE'
-          CALL message( 'ls_forcing', 'PA0371', 0, 0, 0, 6, 0 )
-          lsf_surf = .FALSE.
-       ENDIF
-
-!
-!--    Go to the end of the list with surface variables
-       DO WHILE ( ierrn == 0 )
-          READ ( finput, *, IOSTAT = ierrn ) r_dummy
-       ENDDO
-
-!
-!--    Profiles of ug, vg and w_subs are read in (large scale forcing)
-
-       nt = 0
-       DO WHILE ( time_vert(nt) < end_time )
-          nt = nt + 1
-          hash = "#"
-          ierrn = 1 ! not zero
-!
-!--       Search for the next line consisting of "# time", 
-!--       from there onwards the profiles will be read
-          DO WHILE ( .NOT. ( hash == "#" .AND. ierrn == 0 ) ) 
-             READ ( finput, *, IOSTAT=ierrn ) hash, time_vert(nt)
-             IF ( ierrn < 0 )  THEN 
-                WRITE( message_string, * ) 'No time dependent vertical profiles',&
-                                 ' in&LSF_DATA for end of run found'
-                CALL message( 'ls_forcing', 'PA0372', 1, 2, 0, 6, 0 )
-             ENDIF
-          ENDDO
-
-          IF ( nt == 1 .AND. time_vert(nt) > end_time ) EXIT
-
-          READ ( finput, *, IOSTAT=ierrn ) lowheight, lowug_vert, lowvg_vert,  &
-                                           lowwsubs_vert, low_td_lsa_lpt,      &
-                                           low_td_lsa_q, low_td_sub_lpt,       &
-                                           low_td_sub_q
+             message_string = 'file LSF_DATA does not exist'
+             CALL message( 'ls_forcing', 'PA0368', 1, 2, 0, 6, 0 )
+          ENDIF
+
+          ierrn = 0
+!
+!--       First three lines of LSF_DATA contain header
+          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+          READ ( finput, FMT='(a100)', IOSTAT=ierrn ) chmess
+
           IF ( ierrn /= 0 )  THEN
              message_string = 'errors in file LSF_DATA'
@@ -538,81 +1195,146 @@
           ENDIF
 
-          READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,            &
-                                           highvg_vert, highwsubs_vert,        &
-                                           high_td_lsa_lpt, high_td_lsa_q,     &
-                                           high_td_sub_lpt, high_td_sub_q
-      
-          IF ( ierrn /= 0 )  THEN
-             message_string = 'errors in file LSF_DATA'
-             CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
-          ENDIF
-
-
-          DO  k = nzb, nzt+1
-             IF ( highheight < zu(k) )  THEN
-                lowheight      = highheight
-                lowug_vert     = highug_vert
-                lowvg_vert     = highvg_vert
-                lowwsubs_vert  = highwsubs_vert
-                low_td_lsa_lpt = high_td_lsa_lpt
-                low_td_lsa_q   = high_td_lsa_q
-                low_td_sub_lpt = high_td_sub_lpt
-                low_td_sub_q   = high_td_sub_q
-
-                ierrn = 0
-                READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,      &
-                                                 highvg_vert, highwsubs_vert,  &
-                                                 high_td_lsa_lpt,              &
-                                                 high_td_lsa_q,                &
-                                                 high_td_sub_lpt, high_td_sub_q
-
-                IF ( ierrn /= 0 )  THEN
-                   WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm ', &
-                        'is higher than the maximum height in LSF_DATA which ',&
-                        'is ', lowheight, 'm. Interpolation on PALM ',         &
-                        'grid is not possible.'
-                   CALL message( 'ls_forcing', 'PA0395', 1, 2, 0, 6, 0 )
+!
+!--       Surface values are read in
+          nt     = 0
+          ierrn = 0
+
+          DO WHILE ( time_surf(nt) < end_time )
+             nt = nt + 1
+             READ ( finput, *, IOSTAT = ierrn ) time_surf(nt), shf_surf(nt),   &
+                                                qsws_surf(nt), pt_surf(nt),    &
+                                                q_surf(nt), p_surf(nt)
+
+             IF ( ierrn /= 0 )  THEN
+               WRITE ( message_string, * ) 'No time dependent surface variables ' //&
+                                 'in&LSF_DATA for end of run found'
+
+                CALL message( 'ls_forcing', 'PA0363', 1, 2, 0, 6, 0 )
+             ENDIF
+          ENDDO
+
+          IF ( time_surf(1) > end_time )  THEN
+             WRITE ( message_string, * ) 'Time dependent surface variables in ' // &
+                                         '&LSF_DATA set in after end of ' ,        &
+                                         'simulation - lsf_surf is set to FALSE'
+             CALL message( 'ls_forcing', 'PA0371', 0, 0, 0, 6, 0 )
+             lsf_surf = .FALSE.
+          ENDIF
+
+!
+!--       Go to the end of the list with surface variables
+          DO WHILE ( ierrn == 0 )
+             READ ( finput, *, IOSTAT = ierrn ) r_dummy
+          ENDDO
+
+!
+!--       Profiles of ug, vg and w_subs are read in (large scale forcing)
+
+          nt = 0
+          DO WHILE ( time_vert(nt) < end_time )
+             nt = nt + 1
+             hash = "#"
+             ierrn = 1 ! not zero
+!
+!--          Search for the next line consisting of "# time", 
+!--          from there onwards the profiles will be read
+             DO WHILE ( .NOT. ( hash == "#" .AND. ierrn == 0 ) ) 
+                READ ( finput, *, IOSTAT=ierrn ) hash, time_vert(nt)
+                IF ( ierrn < 0 )  THEN 
+                   WRITE( message_string, * ) 'No time dependent vertical profiles',&
+                                    ' in&LSF_DATA for end of run found'
+                   CALL message( 'ls_forcing', 'PA0372', 1, 2, 0, 6, 0 )
                 ENDIF
-
+             ENDDO
+
+             IF ( nt == 1 .AND. time_vert(nt) > end_time ) EXIT
+
+             READ ( finput, *, IOSTAT=ierrn ) lowheight, lowug_vert, lowvg_vert,&
+                                              lowwsubs_vert, low_td_lsa_lpt,    &
+                                              low_td_lsa_q, low_td_sub_lpt,     &
+                                              low_td_sub_q
+             IF ( ierrn /= 0 )  THEN
+                message_string = 'errors in file LSF_DATA'
+                CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
              ENDIF
 
-!
-!--          Interpolation of prescribed profiles in space 
-             fac = (highheight-zu(k))/(highheight - lowheight)
-
-             ug_vert(k,nt)    = fac * lowug_vert                               &
-                                + ( 1.0_wp - fac ) * highug_vert
-             vg_vert(k,nt)    = fac * lowvg_vert                               &
-                                + ( 1.0_wp - fac ) * highvg_vert
-             wsubs_vert(k,nt) = fac * lowwsubs_vert                            &
-                                + ( 1.0_wp - fac ) * highwsubs_vert
-
-             td_lsa_lpt(k,nt) = fac * low_td_lsa_lpt                           &
-                                + ( 1.0_wp - fac ) * high_td_lsa_lpt
-             td_lsa_q(k,nt)   = fac * low_td_lsa_q                             &
-                                + ( 1.0_wp - fac ) * high_td_lsa_q
-             td_sub_lpt(k,nt) = fac * low_td_sub_lpt                           &
-                                + ( 1.0_wp - fac ) * high_td_sub_lpt
-             td_sub_q(k,nt)   = fac * low_td_sub_q                             &
-                                + ( 1.0_wp - fac ) * high_td_sub_q
-
-          ENDDO
-
-       ENDDO 
-
-!
-!--    Large scale vertical velocity has to be zero at the surface
-       wsubs_vert(nzb,:) = 0.0_wp
- 
-       IF ( time_vert(1) > end_time )  THEN
-          WRITE ( message_string, * ) 'Time dependent large scale profile ',   &
-                             'forcing from&LSF_DATA sets in after end of ' ,   &
-                             'simulation - lsf_vert is set to FALSE'
-          CALL message( 'ls_forcing', 'PA0373', 0, 0, 0, 6, 0 )
-          lsf_vert = .FALSE.
-       ENDIF
-
-       CLOSE( finput )
-
+             READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,         &
+                                              highvg_vert, highwsubs_vert,     &
+                                              high_td_lsa_lpt, high_td_lsa_q,  &
+                                              high_td_sub_lpt, high_td_sub_q
+         
+             IF ( ierrn /= 0 )  THEN
+                message_string = 'errors in file LSF_DATA'
+                CALL message( 'ls_forcing', 'PA0369', 1, 2, 0, 6, 0 )
+             ENDIF
+
+
+             DO  k = nzb, nzt+1
+                IF ( highheight < zu(k) )  THEN
+                   lowheight      = highheight
+                   lowug_vert     = highug_vert
+                   lowvg_vert     = highvg_vert
+                   lowwsubs_vert  = highwsubs_vert
+                   low_td_lsa_lpt = high_td_lsa_lpt
+                   low_td_lsa_q   = high_td_lsa_q
+                   low_td_sub_lpt = high_td_sub_lpt
+                   low_td_sub_q   = high_td_sub_q
+
+                   ierrn = 0
+                   READ ( finput, *, IOSTAT=ierrn ) highheight, highug_vert,    &
+                                                    highvg_vert, highwsubs_vert,&
+                                                    high_td_lsa_lpt,            &
+                                                    high_td_lsa_q,              &
+                                                    high_td_sub_lpt, high_td_sub_q
+
+                   IF ( ierrn /= 0 )  THEN
+                      WRITE( message_string, * ) 'zu(',k,') = ', zu(k), 'm ', &
+                           'is higher than the maximum height in LSF_DATA which ',&
+                           'is ', lowheight, 'm. Interpolation on PALM ',         &
+                           'grid is not possible.'
+                      CALL message( 'ls_forcing', 'PA0395', 1, 2, 0, 6, 0 )
+                   ENDIF
+
+                ENDIF
+
+!
+!--             Interpolation of prescribed profiles in space 
+                fac = (highheight-zu(k))/(highheight - lowheight)
+
+                ug_vert(k,nt)    = fac * lowug_vert                            &
+                                   + ( 1.0_wp - fac ) * highug_vert
+                vg_vert(k,nt)    = fac * lowvg_vert                            &
+                                   + ( 1.0_wp - fac ) * highvg_vert
+                wsubs_vert(k,nt) = fac * lowwsubs_vert                         &
+                                   + ( 1.0_wp - fac ) * highwsubs_vert
+
+                td_lsa_lpt(k,nt) = fac * low_td_lsa_lpt                        &
+                                   + ( 1.0_wp - fac ) * high_td_lsa_lpt
+                td_lsa_q(k,nt)   = fac * low_td_lsa_q                          &
+                                   + ( 1.0_wp - fac ) * high_td_lsa_q
+                td_sub_lpt(k,nt) = fac * low_td_sub_lpt                        &
+                                   + ( 1.0_wp - fac ) * high_td_sub_lpt
+                td_sub_q(k,nt)   = fac * low_td_sub_q                          &
+                                   + ( 1.0_wp - fac ) * high_td_sub_q
+
+             ENDDO
+
+          ENDDO 
+
+!
+!--       Large scale vertical velocity has to be zero at the surface
+          wsubs_vert(nzb,:) = 0.0_wp
+    
+          IF ( time_vert(1) > end_time )  THEN
+             WRITE ( message_string, * ) 'Time dependent large scale profile ',&
+                                'forcing from&LSF_DATA sets in after end of ' ,&
+                                'simulation - lsf_vert is set to FALSE'
+             CALL message( 'ls_forcing', 'PA0373', 0, 0, 0, 6, 0 )
+             lsf_vert = .FALSE.
+          ENDIF
+
+          CLOSE( finput )
+
+       ENDIF
 
     END SUBROUTINE lsf_init
@@ -1396,3 +2118,4 @@
     END SUBROUTINE nudge_ref
 
+
  END MODULE lsf_nudging_mod
Index: palm/trunk/SOURCE/local_stop.f90
===================================================================
--- palm/trunk/SOURCE/local_stop.f90	(revision 2693)
+++ palm/trunk/SOURCE/local_stop.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file local_stop.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/local_system.f90
===================================================================
--- palm/trunk/SOURCE/local_system.f90	(revision 2693)
+++ palm/trunk/SOURCE/local_system.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file local_system.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/local_tremain.f90
===================================================================
--- palm/trunk/SOURCE/local_tremain.f90	(revision 2693)
+++ palm/trunk/SOURCE/local_tremain.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file local_tremain.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/local_tremain_ini.f90
===================================================================
--- palm/trunk/SOURCE/local_tremain_ini.f90	(revision 2693)
+++ palm/trunk/SOURCE/local_tremain_ini.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file local_tremain_ini.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/lpm.f90
===================================================================
--- palm/trunk/SOURCE/lpm.f90	(revision 2693)
+++ palm/trunk/SOURCE/lpm.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file lpm.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/lpm_advec.f90	(revision 2693)
+++ palm/trunk/SOURCE/lpm_advec.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file lpm_advec.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/lpm_boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2693)
+++ palm/trunk/SOURCE/lpm_boundary_conds.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file lpm_boundary_conds.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90
===================================================================
--- palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 2693)
+++ palm/trunk/SOURCE/lpm_calc_liquid_water_content.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file lpm_calc_liquid_water_content.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
Index: palm/trunk/SOURCE/lpm_collision_kernels.f90
===================================================================
--- palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 2693)
+++ palm/trunk/SOURCE/lpm_collision_kernels.f90	(revision 2696)
@@ -1,5 +1,5 @@
 !> @file lpm_collision_kernels.f90
 !------------------------------------------------------------------------------!
-! This file is part of PALM.
+! This file is part of the PALM model system.
 !
 ! PALM is free software: you can redistribute it and/or modify it under the
